<%@LANGUAGE="VBSCRIPT" CODEPAGE="1252"%>
<%
Option Explicit

'***************************************************************
'*                                                             *
'*   Est cdigo fu desarrollado por el rea de Desarrollo    *
'* del Rectorado de la Universidad Tecnolgica Nacional de     *
'* Argentina y forma parte del mdulo SysacadWEB del Sistema   *
'* de gestin acadmica SYSACAD.                               *
'*                                                             *
'*   Publicado bajo licencia GNU. Puede copiarse y modificarse *
'* mientras se mantenga este comentario y toda modificacin se *
'* enve a soportesysacad@asiutn.org.ar para que pueda ser     *
'* utilizada libremente por otros desarrolladores.             *
'*                                                             *
'*   Este archivo es normalmente modificado en cada actualiza- *
'* cin del mdulo SysacadWEB por lo que no es conveniente su  *
'* modificacin porque se perdera la compatibilidad con       *
'* versiones futuras. Si se desea cambiar el diseo de la      *
'* pgina puede hacerse usando las variables de CSS en el      *
'* archivo config.asp. Para informacin de las variables       *
'* vase configDefecto.asp                                     *
'*                                                             *
'***************************************************************
%>
<!--#include file="kermet.asp" -->
<%
  '***************************************************************
  '*  Variables de sesion                                        *
  '***************************************************************

  if session("logueado")<>"SI" then
    response.redirect("loginAlumno.asp?refrescar")
  end if	
  dim error, oJSON_send, usr_boleto, pass_boleto
  dim url_rcv, tid, progress, error_http, msg_error
  error_http = false
  error = false
  
  ' Credenciales para enviar los datos al sistema del boleto estudiantil
  usr_boleto = "u7NF8AP4od"
  pass_boleto = "9a55F8Av!"

  ' URL a modificar para enviar los datos al sistemad de boleto estudiantil
  Dim url: url = "https://boletoeducativo.gba.gob.ar/ws/benefit-request"

  ' Esta funcion borra lo contenido en parametro1
  call InicioPeticion

  ' La funcion campoP1Json recibe el JSON armado
  Set oJSON_send = New aspJSON
  
  With oJSON_send.data
    .Add "idvista", "3135987"
    .Add "student_legajo", session("legajo")
  end with

  call campoP1Json(oJSON_send.JSONoutput())

  if not ejecutarPeticionJson(13,timeOut3) then
    error=true
  end if

  'Funcion para chequeo de respuestas HTTP
  function checkStatusValue(statusHTTP)
    'Decodifico el mensaje JSON obtenido por la peticion 13
    dim oJSON_rcv, oJSON_send_sysacad, id_progress, status_rcv

    set oJSON_rcv = New aspJSON
    error_http = false
    ' Verifico si hubo una respuesta correcta con 2XX
    If Left(statusHTTP.Status, 1) = 2 Then
      'Cargo el JSON que me devuelve la subsecretaria de transporte
      oJSON_rcv.loadJSON(statusHTTP.responseText)

      'Obtengo los valores de estado, link, id de tramite y el estado del progreso
      status_rcv = oJSON_rcv.data("status")
      if status_rcv = 201 then 
        url_rcv = oJSON_rcv.data("data").item("redirect-url")
        tid = oJSON_rcv.data("data").item("tid")
        id_progress = oJSON_rcv.data("data").item("in_progress")

        ' in_ progress devuelve 0 si no tiene un trmite vigente (en progreso) y 1 si lo tiene.
        if id_progress = 0 then
          progress = "Tramite pendiente de finalizacion"
        else id_progress = 1
          progress = "Tramite finalizado"
        'Si el tramite esta finalizado no hay que mostrar el link
          url_rcv = ""
        end if

        ' Procedo a guardar los datos que vienen del JSON con la peticion 14
        ' Esta funcion borra lo contenido en parametro1
        call InicioPeticion

        ' La funcion campoP1Json recibe el id de la vista y el numero de legajo   
        Set oJSON_send_sysacad = New aspJSON
              
        With oJSON_send_sysacad.data
          .Add "student_legajo", session("legajo")
          .Add "tid", tid
          .Add "link_sube", url_rcv
          .Add "inicio_tramite_sube", date + time
        end with

        call campoP1Json(oJSON_send_sysacad.JSONoutput())

        if not ejecutarPeticionJson(14,timeOut3) then
          error=true
        end if
            
        ' Los siguientes mensajes son para el programador a excepcion del status 500 
        ' el cual es un error interno del sistema de la subsecretaria
      elseif status_rcv = 400 Then
      ' Error de validacin de datos, el objeto mensaje ofrece la causa del error
        error_http=true
        msg_error= "Error de validacin de datos"
            
      elseif status_rcv = 403 Then
      ' Error de credenciales
        error_http=true
        msg_error= "Error de credenciales"

      elseif status_rcv = 409 then
      ' La persona ya tiene un beneficio asignado
        tid = tid_sysacad
        url_rcv = ""
        progress = "Tramite finalizado, ya posee un beneficio asignado"

      elseif status_rcv = 423 Then
      ' La persona tiene un beneficio pero deshabilitado.
        error_http=true
        msg_error= "Error: La persona tiene un beneficio pero deshabilitado"

      elseif status_rcv = 439 Then
      ' La IP desde la cual se enva el request no est autorizada.
        error_http=true
        msg_error= "Error: La IP desde la cual se enva el request no est autorizada."

      elseif status_rcv = 500 Then 
      ' Error interno del mensaje
        error_http=true
        msg_error= "Error interno del sistema, reintente en unos minutos"  
      end if

    elseif statusHTTP.Status = 500 Then 
    ' Error interno del mensaje
      error_http=true
      msg_error= "Error interno del sistema, reintente en unos minutos"
          
    else
    'Error desconocido
      error_http=true
      msg_error= "Server returned: " & statusHTTP.Status & " " & statusHTTP.StatusText
    end if
  end function


  '***************************************************************
  '*  Obtencion del tramite guardado en el Sysacad               *
  '***************************************************************

  'Decodifico el mensaje JSON obtenido por la peticion 13
  dim oJSON
  set oJSON = New aspJSON

  'Cargo el JSON proveniente del sistema de peticiones
  oJSON.loadJSON(parametro2)

  dim datos, this, registro_vacio
  dim flag_facultad, flag_tipo_doc, flag_tiempo_solicitud
  
  registro_vacio = 0
  flag_facultad = 0
  flag_tipo_doc = 0
  flag_tiempo_solicitud = 0

  dim student_legajo, nro_documento, nro_documento_tipo, tipodoc_sysacad, nom_tipo_doc, nombre_ape, id_facultad, student_department
  dim nom_ape_split, link_sube_sysacad, inicio_tramite_sube, tid_sysacad, tiempo_actual, diff_tiempo
  dim msg_resp_sysacad, sv_dia, sv_fecha
 
  'Me quedo con el conjunto de datos del campo registros
  For Each datos In oJSON.data("registros")
      Set this = oJSON.data("registros").item(datos)
      student_legajo = this.item("student_legajo")
      nro_documento = this.item("student_id")
      tipodoc_sysacad = this.item("student_id_type")
      nom_tipo_doc = this.item("nom_tipo_doc")
      nombre_ape = this.item("nombre_alumno")
      id_facultad = this.item("id_facultad")
      student_department = this.item("student_departament")
      msg_resp_sysacad = this.item("respuesta_sube")
      tid_sysacad = this.item("tid")
      link_sube_sysacad = this.item("link_sube")
      inicio_tramite_sube = this.item("inicio_tramite_sube")
      'Si hay datos uso un flag
      registro_vacio = registro_vacio + 1
  Next

  '***************************************************************
  '*  Cambio de valores para el sistema del boleto               *
  '***************************************************************

  ' Si el registro se encuentra vacio significa que el alumno no es regular.
  if registro_vacio > 0 then
    'Obtengo el apellido en el campo 0 y el nombre en el campo 1 de nom_ape
    nom_ape_split = Split(nombre_ape,", ")

    ' Obtengo los datos de fecha y hora guardados en el sysacad
    if inicio_tramite_sube <> "" then
      sv_fecha = split(inicio_tramite_sube, "T")' 
      sv_dia = split(sv_fecha(1),"-")
    end if  

  end if

  ' Flag para evitar que se generen nuevas solicitudes dentro del lapso de 20 min (1200 segundos).
  ' Se obtiene la diferencia entre la primer solicitud y el tiempo actual del servidor.
  if inicio_tramite_sube <> "" then
    tiempo_actual = date + time
    diff_tiempo = DateDiff("s",sv_fecha(0) + " " + sv_dia(0), tiempo_actual)
  end if

  'Response.Write diff_tiempo

  'Mientras este dentro de los 20 minutos del ministerio esta habilitado
  if tid_sysacad = "" then
    flag_tiempo_solicitud = 0 ' Con 0 indico que es la primera vez que se genera
  elseif (diff_tiempo = "" or diff_tiempo = 0 or isnull(diff_tiempo)) and msg_resp_sysacad = "TRAMITE_EXPIRADO" then
    flag_tiempo_solicitud = 0 ' Este caso es para corregir aquellos que no guardo bien la fecha
  elseif diff_tiempo < 1200 and tid_sysacad <> "" then
    flag_tiempo_solicitud = 1 ' Con 1 indico que ya se genero 1 vez y esta corriendo el tiempo
  elseif diff_tiempo >= 1200 and tid_sysacad <> "" then
    flag_tiempo_solicitud = 2 ' Con 2 indico que se paso de tiempo
  end if

  ' Correccion sobre el tipo de documento en el sistema de la subsecretaria:
  ' 0: DNI
  ' 1: DNI temporario
  ' 2: Cedula de identidad (extranjera)
  ' 18: Libreta de enrolamiento
  ' 19: Libreta civica
  ' 90: Pasaporte (Extranjero)

  if tipodoc_sysacad = 1 then
    nro_documento_tipo = 0
  elseif tipodoc_sysacad = 5 then
    nro_documento_tipo = 1
  elseif tipodoc_sysacad = 3 then
    nro_documento_tipo = 19
  elseif tipodoc_sysacad = 4 then
    nro_documento_tipo = 18
  elseif tipodoc_sysacad = 6 then
    nro_documento_tipo = 90
  else 
    flag_tipo_doc = 1
  end if

  ' Chequeo de facultades permitidas para realizar el tramite
  ' 1-Avellaneda, 2- Bahia Blanca, 5-La Plata, 9-San Nicolas, 15-Haedo, 18-Pacheco, 
  ' 21-Trenque Lauquen, 23-Delta, 36- Mar del Plata
  if id_facultad = 1 or id_facultad = 5 or id_facultad = 15 or id_facultad = 18 or id_facultad = 23 then
    flag_facultad = 0 ' con 0 la facultad esta habilitada
  elseif id_facultad = 2 or id_facultad = 9 or id_facultad = 21 or id_facultad = 36 then
    flag_facultad = 0
  else
    flag_facultad = 1
  end if

  '***************************************************************
  '*  Consulta al sistema del boleto estudiantil                 *
  '***************************************************************

  ' En el caso que no haya algun tramite iniciado y que sea una facultad habilitada
  if msg_resp_sysacad <> "OK" and flag_facultad = 0 then
    'Decodifico el mensaje JSON obtenido por la peticion 13
    dim oJSON2
    Set oJSON2 = New aspJSON

    ' Creo el objeto JSON para enviar a la subsecretaria de transporte
    With oJSON2.data
      .Add "user", usr_boleto                     
      .Add "password", pass_boleto
      .Add "student_id", nro_documento
      .Add "student_id_type", nro_documento_tipo
      .Add "student_name", nom_ape_split(1)
      .Add "student_last_name", nom_ape_split(0)
      '.Add "student_department", student_department
      .Add "student_department", "UTNFRA"
    end With

    Dim http: Set http = Server.CreateObject("WinHttp.WinHttpRequest.5.1")
      
    ' Si ocurre un problema con certificados, descomentantar la siguiente linea mientras
    ' se actualizan los mismos.
    http.Option(4) = &H3300

    if flag_tiempo_solicitud = 0 then
      if msg_resp_sysacad = "" or msg_resp_sysacad = "TRAMITE_EXPIRADO" then
      ' Caso inicial
        With http
          Call .Open("POST", url, False)
          Call .SetRequestHeader("Content-Type", "application/json")
          ' Envio el string armado
          Call .Send(oJSON2.JSONoutput)
        End With

        Call checkStatusValue(http)
      end if

    elseif flag_tiempo_solicitud = 1 then
      ' Si esta el tramite en curso dentro de los 20 min se muestran los mismos datos
      tid = tid_sysacad
      url_rcv = link_sube_sysacad
      progress = "Tramite pendiente de finalizacion"

    elseif flag_tiempo_solicitud = 2 and msg_resp_sysacad = "TRAMITE_EXPIRADO" then
      ' Caso en el que se expiro el tiempo y se recibio respuesta del ministerio
      With http
        Call .Open("POST", url, False)
        Call .SetRequestHeader("Content-Type", "application/json")
        ' Envio el string armado
        Call .Send(oJSON2.JSONoutput)
      End With
      Call checkStatusValue(http)

    elseif flag_tiempo_solicitud = 2 and msg_resp_sysacad <> "TRAMITE_EXPIRADO" and msg_resp_sysacad <> "" then
      ' Este caso ocurre una vez que se supera el tiempo y no se obtiene ninguna respuesta
      tid = tid_sysacad
      url_rcv = ""
      progress = "Tramite incompleto, contactese con el administrador del sistema"
    end if
  
  elseif msg_resp_sysacad = "OK" and flag_facultad = 0 then
    ' Caso de que el tramite este finalizado
    tid = tid_sysacad
    url_rcv = ""
    progress = "Tramite finalizado, beneficio otorgado"
  end if
%>


<!DOCTYPE html>
<html>
<head >
<title>Boleto estudiantil</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<% call SetEstilo() %>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>

</head>
<body>
<!--#include file="local/membrete.htm" -->
<pre>
</pre>

<table border="0" align="center" width="700" cellpadding="0" cellspacing="0">
  <tr>
    <td class="tituloTabla">
      <div ID="nombre1"><% response.write("Estado de tramite del boleto estudiantil de " & rtrim(session("nombre"))) %></div>
    </td>
  </tr>
  <tr><td bgcolor=<% response.write(ColorTabla) %>>
    <table width="100%" cellpadding="4" cellspacing="1" border="0">
    <!-- Consulto si posee un tramite de boleto estudiantil -->
      <tr>
        <td>
          <table  width="100%" align=center border=1 cellspacing=0 cellpadding=1  bgcolor=<% response.write(ColorFondoTabla) %>>
          <% 
            '***************************************************************
            '*  Respuestas mostradas al alumno                             *
            '***************************************************************

            if error_http <> true then  
              ' Verifico si el registro vino vacio o con datos, en el caso vacio significa que no es regular
              if registro_vacio <> 0 then
                if flag_facultad = 0 and flag_tipo_doc = 0 then
                    response.write("<tr class=""textoTabla""><th>Estado</th><th>N Trmite</th><th>Link</th></tr>")
                    response.write("<tr class=""textoTabla""><td align=center>" & progress & "</td><td align=center>" & tid & "</td>")
                    if url_rcv <> "" then
                      response.write ("<td align=center><a href=" & url_rcv &"> Link_Formulario_Solicitud </a> </td></tr>")
                      response.write("<tr class=""textoTabla""><td colspan= ""3"" align=left><ul> ") 
                      response.write("<li>Recuerde que para completar este formulario tiene <b>20</b> minutos </li>")
                      response.write("<li>El formulario le va a solicitar <b>datos personales</b> y el <b>CUIL</b></li>")
                      response.write("<li>Tenga a mano su nmero de tarjeta <b>SUBE</b> asociada a su documento </li>")
                      response.write("<li>Solo va a poder seleccionar hasta un<i><b> mximo de <u>4</u> lneas</b></i> de transporte </li></ul>") 
                      response.write("<ol><b>Nota importante:</b></ol>") 
                      response.write("<ul><li>El trmite tiene una fecha de cierre del <b>17</b> de cada mes</li>")
                      response.write("<li>Luego de la fecha de cierre y de haber finalizado el trmite, la acreditacin puede demorar <b> hasta <u>10</u> das hbiles</b></li>") 
                      response.write("<li>Posterior a el da <b>17</b>, el tramite se har efectivo luego del 17 del <b><i>prximo mes</i></b></li></ul></td></tr>") 
                     else
                      response.write ("<td align=center> - </td></tr>")
                    end if
                elseif flag_facultad = 1 and flag_tipo_doc = 0 then
                ' Aviso si no esta permitida la facultad
                    response.write("<tr class=""textoTabla""><td align=center>Facultad no permitida para realizar el tramite </td></tr>")
                elseif flag_facultad = 0 and flag_tipo_doc = 1 then
                ' Aviso si el tipo de documento no es el correcto para iniciar tramite
                    response.write("<tr class=""textoTabla""><td align=center>Tipo de documento invalido, por favor contactese con la secretaria academica de la facultad para actualizar su documento </td></tr>")
                elseif flag_facultad = 1 and flag_tipo_doc = 1 then
                ' Aviso si el tipo de documento no es el correcto para iniciar tramite
                    response.write("<tr class=""textoTabla""><td align=center>Facultad no permitida para realizar el tramite </td></tr>")
                    response.write("<tr class=""textoTabla""><td align=center>Tipo de documento invalido, por favor contactese con la secretaria academica de la facultad para actualizar su documento </td></tr>")    
                end if

              else registro_vacio = 0
              ' Alumno no regular, no puede iniciar el tramite. Regularice su situacin 
                response.write("<tr class=""textoTabla""><td align=center>Error: Alumno no regular, no puede iniciar el tramite. Regularice su situacin  </td></tr>")
              end if
            else 
              ' Alumno no regular, no puede iniciar el tramite. Regularice su situacin 
                response.write("<tr class=""textoTabla""><td align=center>" & msg_error & "</td></tr>")
            end if
           %>
          </table>
          </td>
      </tr>
    </table>
  </td></tr>
</table>

<P class="textoTabla"  { font-size:120%} align=center>
<!--<a href="certificadoExamen.asp?refrescar">Certificado de exmenes</a><br>-->
<a href="menuAlumno.asp">Volver a men principal</a>
</p>

<!--call EjecutarCodigo(pieMateriasExamen) %> -->
<!--#include file="local/pie.htm" -->

</body>
</html>