<%@LANGUAGE="VBSCRIPT" CODEPAGE="1252"%>
<%
'***************************************************************
'*                                                             *
'*   Este cdigo fue desarrollado por el rea de Desarrollo     *
'* del Rectorado de la Universidad Tecnolgica Nacional de      *
'* Argentina y forma parte del mdulo SysacadWEB del Sistema    *
'* de gestin acadmica SYSACAD.                                *
'*                                                             *
'*   Publicado bajo licencia GNU. Puede copiarse y modificarse  *
'* mientras se mantenga este comentario y toda modificacin se  *
'* enve a soportesysacad@asiutn.org.ar para que pueda ser      *
'* utilizada libremente por otros desarrolladores.              *
'*                                                             *
'*   Este archivo es normalmente modificado en cada actualiza-  *
'* cin del mdulo SysacadWEB por lo que no es conveniente su   *
'* modificacin porque se perdera la compatibilidad con        *
'* versiones futuras. Si se desea cambiar el diseo de la       *
'* pgina puede hacerse usando las variables de CSS en el       *
'* archivo config.asp. Para informacin de las variables        *
'* vase configDefecto.asp                                      *
'*                                                             *
'***************************************************************
%>
<!--#include file="kermet.asp" -->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
  <title>
    <%
  If Request.QueryString("cert") = "CertRegular" Then      
    Response.Write("Certificado de alumno regular")
  ElseIf Request.QueryString("cert") = "ActAcademica" Then
    Response.Write("Actividad Acad&eacute;mica")
  Else
    Response.Write("Error")
  End If
    %>
  </title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  <%
  Call SetEstilo()
  dim rutaArchivoURL, error_archivo
  
  error_archivo = false
  rutaArchivoExiste = rutaLocalCertificado & "/archivos/" & Request.QueryString("cert") & "/" & Request.QueryString("file")
  rutaArchivoURL = rutaWebCertificado & "/archivos/" & Request.QueryString("cert") & "/" & Request.QueryString("file")
  
  dim fs
  set fs=Server.CreateObject("Scripting.FileSystemObject")
  ' Esta ruta es la del servidor, verifico si existe
  if fs.FileExists(rutaArchivoExiste) then
    rutaArchivoURL = rutaWebCertificado & "/archivos/" & Request.QueryString("cert") & "/" & Request.QueryString("file")
  Else
    error_archivo=true
  end if
  set fs=nothing

  %>

  <!-- Agrega la referencia a la biblioteca PDF.js -->
  <script src="Js/build/pdf.js"></script>

  <!-- Agrega el cdigo JavaScript para cargar el PDF -->
  <script>
    document.addEventListener('DOMContentLoaded', function() {
      var url = '<%= rutaArchivoURL %>';

      // Carga el PDF utilizando PDF.js
      pdfjsLib.getDocument(url).promise.then(function(pdf) {
        var canvasContainer = document.getElementById('pdf-container');

        // Itera sobre todas las pginas del PDF
        var pagesPromises = [];
        for (var pageNumber = 1; pageNumber <= pdf.numPages; pageNumber++) {
          pagesPromises.push(pdf.getPage(pageNumber));
        }

        // Procesa todas las promesas de las pginas del PDF
        Promise.all(pagesPromises).then(function(pages) {
          pages.forEach(function(page, index) {
            var scale = 1.5;
            var viewport = page.getViewport({ scale: scale });

            // Crea un elemento <canvas> para cada pgina
            var canvas = document.createElement('canvas');
            canvasContainer.appendChild(canvas);

            // Agrega una lnea separadora antes de cada pgina, excepto la primera
            if (index >= 0) {
              var separator = document.createElement('hr');
              canvasContainer.appendChild(separator);
            }

            // Prepara el <canvas> del PDF
            var context = canvas.getContext('2d');
            canvas.height = viewport.height;
            canvas.width = viewport.width;

            // Renderiza la pgina en el <canvas>
            page.render({
              canvasContext: context,
              viewport: viewport
            });
          });
        }).catch(function(error) {
          // En caso de error al cargar el PDF, muestra el mensaje de error
          var errorMessage = document.getElementById('error-message');
          errorMessage.style.display = 'block';
        });
      });
    });
  </script>
</head>

<body class="body">
  <!--#include file="local/membrete.htm" -->

<table align="center" width="auto" cellpadding="8" cellspacing="0">
  <tr>
    <th class="tituloTabla">
      <% If Request.QueryString("cert") = "CertRegular" Then %>
        Certificado de alumno regular
      <% ElseIf Request.QueryString("cert") = "ActAcademica" Then %>
        Actividad Acad&eacute;mica
      <% Else %>
        Error 
        <tr class="textoTabla"> 
          <td align="center" height="auto"> Error, enlace no formado correctamente</td> 
        </tr>
      <% End If %>
    </th>
  </tr>
  <tr class="textoTabla">
    <td align="center" height="auto">
      <div id="pdf-container"></div>
      <p id="error-message" style="display: none;">No se puede mostrar el archivo PDF en estos momentos. Puede descargarlo m&aacute;s abajo.</p>
    </td>
  </tr>
  <% If Request.QueryString("cert") = "CertRegular" Or Request.QueryString("cert") = "ActAcademica" Then %>
    <tr class="textoTabla">
      <td id="link-descarga" align="center">
      <% If error_archivo = True Then %>
        No existe el archivo, debe generarlo previamente
      <% Else %>
        <a href="<%= rutaArchivoURL %>" download="<%
        If Request.QueryString("cert") = "CertRegular" Then      
          Response.Write("Certificado.pdf")
        Else
          Response.Write("ActAcad&eacute;mica.pdf")
        End If %>">Descargar archivo</a>
      <% End If %>
      </td>
    </tr>
  <% End If %>
</table>



  <% Call EjecutarCodigo(pieLoginAlumno) %>

  <!--#include file="local/pie.htm" -->
</body>
</html>
